#include <16f876.h>
#include <lcd_lph7906.h>


#define ONE_WIRE_PIN PIN_A4
#define LED PIN_A0
#define KK1 PIN_B5
#define KK2 PIN_B6
#define KK3 PIN_B7


#fuses HS, NOPROTECT, NOPUT, NOWDT, NOBROWNOUT, NOLVP, NOCPD, NOWRT
float value = 0.0;

void onewire_reset();
void onewire_write(int8 data);
int onewire_read();
void ds1820_read_rom(int8 f_rom[8]) ;
float ds1820_read();
float ds1820_read_this(int8 f_rom[8]);
void ds1820_configure(int8 TH, int8 TL, int8 config);
#use delay ( clock=8000000 )

int1 key1,key2,key3,oldkey1,oldkey2,oldkey3,nk1,nk2,nk3,sk;
int8 ss1,ss2,ss3,seccount;
 int8   ds_crc[8];
int1 mnu,sel1,sel2,sel3,param;

#int_RTCC
void RTCC_isr(void) //   
{
key1 = input_state(KK1); if (key1<oldkey1) { nk1=1;}; oldkey1=key1;
key2 = input_state(KK2); if (key2<oldkey2) { nk2=1;}; oldkey2=key2;
key3 = input_state(KK3); if (key3<oldkey3) { nk3=1;}; oldkey3=key3;
seccount++;
if (seccount==400) {sk=1;seccount=0;};
}


void menu1(void)
{
lph_gotoxy(0,7); 
printf(lph_printchar,"             ");
}

void menu2(void)
{
lph_gotoxy(0,7); 
printf(lph_printchar,"            ");
lph_gotoxy(0,7);
lph_print_uparrow();
lph_gotoxy(96,7);
lph_print_downarrow();
}

void menu3(void)
{
lph_gotoxy(0,7); 
printf(lph_printchar,"            ");
}

void scr_clr(void)
{
  lph_erase_y(0); 
  lph_erase_y(1); 
  lph_erase_y(2); 
  lph_erase_y(3); 
  lph_erase_y(4); 
  lph_erase_y(5); 
  lph_erase_y(6); 
}

void scr_bgn (void)
{
lph_gotoxy(0,4); 
//value = ds1820_read_this(ds_crc);
value = ds1820_read();
printf(lph_printchar,"-: %3.1f", value);
lph_print_degree();  lph_printchar("C");    

}

void scr_mnu1 (void)
{
scr_clr();
 lph_gotoxy(15,0);
 printf(lph_printchar,"");
 lph_gotoxy(15,2);
 printf(lph_printchar,"");
if (sel1)
{
 lph_gotoxy(0,0);
lph_print_rightarrow();
lph_clear_xy(0,2);
}

if (sel2)
{
lph_clear_xy(0,0);
 lph_gotoxy(0,2);
lph_print_rightarrow();
}


}

void scr_prm (void)
{
int8 i;
scr_clr();
ds1820_read_rom(ds_crc);
 lph_gotoxy(0,0);
 printf(lph_printchar," ");
 lph_gotoxy(0,1);
 printf(lph_printchar,"FC: %x",ds_crc[0]);
 lph_gotoxy(0,2);
 printf(lph_printchar,"SN: ");

for(i=1; i<7;i++)
{
 printf(lph_printchar,"%x",ds_crc[i]);
}
 lph_gotoxy(0,3);
 printf(lph_printchar,"CRC: %x",ds_crc[7]);

}

void main ( void )
    {
port_b_pullups(TRUE);
nk1=0;nk2=0;nk3=0;seccount=0;
mnu=0;sel1=1;sel2=0;sel3=0;param=0;// 
setup_counters ( RTCC_INTERNAL, RTCC_DIV_256);
enable_interrupts(INT_RTCC);//   
enable_interrupts(GLOBAL);//  
lph_init();
ds1820_read_rom(ds_crc);
/* */
ss1=0;ss2=0;ss3=0;
menu1();
    while(TRUE) 
        {
        if (nk1) 
      {
         nk1=0;
         if ((mnu==1)&(param==0))
         {
            if (sel1)
            {
            sel1=0;
            sel2=1;
            }
            else   
            {
            if (sel2)
            {
            sel1=1;
            sel2=0;
            }
            }
         scr_mnu1();
         }
      };

        if (nk2) 
      {
         nk2=0;
         if (param==1)
         {
         param=0;
         mnu=0;
         scr_clr();
         menu1();
         scr_bgn();
         }
         else
         {
         if ((mnu==0)&(param==0))
         {
            mnu=1;
            menu2();
            scr_mnu1();
         }
         else
         {
         if ((mnu==1)&(sel1==1))
         {
         scr_prm();
         menu3();
         param=1;
         mnu=0;
         }
         if ((mnu==1)&(sel2==1))
         {
         scr_clr();
         scr_bgn();
         menu1();
         mnu=0;
         }
         }
         }
      };

        if (nk3) 
      {
         nk3=0;
         if ((mnu==1)&(param==0))
         {
            if (sel1==1)
            {
            sel1=0;
            sel2=1;
            }
            else
            {
            if (sel2==1)
            {
            sel1=1;
            sel2=0;
            }
            }
         scr_mnu1();
         }
      };
      output_toggle(LED);
   if ((mnu==0)&(param==0))
{
if (sk) 
{
    sk=0;
//scr_clr();
scr_bgn();
}
}
}
}



void onewire_reset() {
    output_low(ONE_WIRE_PIN);       // pull the bus low for reset
    delay_us(500);
    output_float(ONE_WIRE_PIN);     // float the bus high
    delay_us(500);                  // wait-out remaining initialisation window
    output_float(ONE_WIRE_PIN);
}
/*
 * onewire_write(int8 data)
 * Arguments: a byte of data.
 * Description: writes a byte of data to the device.
 */
void onewire_write(int8 data) {
    int8 count;

    for(count = 0; count < 8; ++count) {
        output_low(ONE_WIRE_PIN);
        delay_us(2);                // pull 1-wire low to initiate write time-slot.
        output_bit(ONE_WIRE_PIN, shift_right(&data, 1, 0)); // set output bit on 1-wire
        delay_us(60);               // wait until end of write slot.
        output_float(ONE_WIRE_PIN); // set 1-wire high again,
        delay_us(2);                // for more than 1us minimum.
    }
}

/*
 * onewire_read()
 * Description: reads and returns a byte of data from the device.
 */
int onewire_read() {
    int count, data;

    for(count = 0; count < 8; ++count) {
        output_low(ONE_WIRE_PIN);
        delay_us(2);                // pull 1-wire low to initiate read time-slot.
        output_float(ONE_WIRE_PIN); // now let 1-wire float high,
        delay_us(8);                // let device state stabilise,
        shift_right(&data, 1, input(ONE_WIRE_PIN)); // and load result.
        delay_us(120);              // wait until end of read slot.
    }
    return data;
} 

void ds1820_read_rom(int8 f_rom[8]) 
    {
byte i;
    onewire_reset();
    onewire_write(0x33);            //Skip ROM, address all devices
   for (i=0;i<8;i++)
   {f_rom[i] = onewire_read();}
}

float ds1820_read() 
    {
    int8 busy=0, temp1, temp2;
    signed int16 temp3;
    float result;
   
 //   ds1820_configure(0x00, 0x00, 0x00);     //9 bit resolution

    onewire_reset();
    onewire_write(0xCC);            //Skip ROM, address all devices
    onewire_write(0x44);            //Start temperature conversion

    while(busy == 0)                //Wait while busy (bus is low)
        busy = onewire_read();

    onewire_reset();
    onewire_write(0xCC);            //Skip ROM, address all devices
    onewire_write(0xBE);            //Read scratchpad
    temp1 = onewire_read();
    temp2 = onewire_read();
    temp3 = make16(temp2, temp1);
 
    result = (float) temp3 / 2.0;   //Calculation for DS18S20 with 0.5 deg C resolution
    //result = (float) temp3 / 1.0;    //Calculation for DS18B20
 
//    delay_ms(20);
    return(result);
}

float ds1820_read_this(int8 f_rom[8]) 
    {
   int8 i;
    int8 busy=0, temp1, temp2;
    signed int16 temp3;
    float result;
   
 //   ds1820_configure(0x00, 0x00, 0x00);     //9 bit resolution

    onewire_reset();
    onewire_write(0x55);            //Skip ROM, address all devices
   for (i=0;i<8;i++)
      {onewire_write(f_rom[i]);}
   delay_ms(20);
    onewire_write(0x44);            //Start temperature conversion
    while(busy == 0)                //Wait while busy (bus is low)
        busy = onewire_read();
    onewire_reset();
    onewire_write(0x55);            //Skip ROM, address all devices
   for (i=0;i<8;i++)
      {onewire_write(f_rom[i]);}
    onewire_write(0xBE);            //Read scratchpad
    temp1 = onewire_read();
    temp2 = onewire_read();
    temp3 = make16(temp2, temp1);
     result = (float) temp3 / 2.0;   //Calculation for DS18S20 with 0.5 deg C resolution
    //result = (float) temp3 / 1.0;    //Calculation for DS18B20
    delay_ms(20);
    return(result);
}


/*
 * ds1820_configure(int8 TH, int8 LH, int8 config)
 * Description: writes configuration data to the DS18x20 device
 * Arguments: alarm trigger high, alarm trigger low, configuration
 */
/*
void ds1820_configure(int8 TH, int8 TL, int8 config) {
    onewire_reset();
    onewire_write(0xCC);            //Skip ROM, address all devices
    onewire_write(0x4E);            //Write to scratchpad
    onewire_write(TH);
    onewire_write(TL);
    onewire_write(config);
}

*/
